<template>
  <q-page class="row items-center justify-evenly">
    <!-- <example-component
      title="Example component"
      active
      :todos="todos"
      :meta="meta"
    ></example-component> -->
    <div class="row justify-evenly items-center content-center full-width q-mb-md">
      <div class="col-12 col-md-3 q-pa-md">
        <div class="text-h6">Do you have unused O2 cylinders?</div>
        <div class="text-subtitle1">Help people by listing your supplies. Be polite.</div>
        <q-btn
          no-caps
          class="q-my-md"
          color="accent"
          text-color="black"
          label="Add cylinders"
          to="/new"
        />
        <ul :class="$q.screen.gt.sm ? 'q-gutter-sm' : ''">
          <li>Enter details about your O2 cylinder</li>
          <li>You personal data is not public</li>
          <li>People request O2 supplies</li>
          <li>Only, you can see the numbers of people in need</li>
          <li>You phone is used to find your O2 supply listing</li>
          <li>Help people in need, while maintaining your privacy</li>
        </ul>
      </div>

      <div class="col-12 col-md-3 q-pa-md">
        <div class="text-h6">Do you need O2 cylinders?</div>
        <div class="text-subtitle1">Find your nearest supplies. Be polite.</div>
        <q-select
          class="q-my-md"
          rounded
          standout
          use-input
          v-model="city"
          label="Choose a city"
          :options="cities"
        >
          <template v-slot:no-option>
            <q-item>
              <q-item-section class="text-grey">
                No results
              </q-item-section>
            </q-item>
          </template>
        </q-select>
        <ul :class="$q.screen.gt.sm ? 'q-gutter-sm' : ''">
          <li>Look for the name of your city</li>
          <li>Find the nearest available resources based on PIN code, city, and state</li>
          <li>Your request is sent to people with supplies</li>
          <li>They will call you back</li>
          <li>A team of volunteers is actively working to get the best help possible</li>
        </ul>
      </div>
    </div>

    <q-separator inset />

    <q-infinite-scroll @load="loadCylinderData" style="height: 90vh" class="row justify-center full-width q-gutter-md q-mr-lg q-ml-sm q-mb-xl q-pb-xl">
      <div v-for="(item, index) in items" :key="index" class="col-12 col-sm-5 col-md-3">
        <q-card>
          <q-card-section>
            <div class="text-h5 ellipsis">Cylinder type: {{ item.cylinder_type }}</div>
            <span class="text-p">PIN code: {{ item.pincode }}</span>
          </q-card-section>

          <q-separator inset />

          <q-card-section>
            <div class="text-p ellipsis-2-lines">Capacity: {{ item.quantity }}L</div>
            <span class="text-p">Condition: {{ item.condition }}</span>
          </q-card-section>

          <q-card-actions align="right">
            <q-btn no-caps :to="item.cylinder_id + '/request'">Request</q-btn>
          </q-card-actions>
        </q-card>
      </div>
      <template v-slot:loading>
        <div class="row justify-center q-my-md">
          <q-spinner-dots color="primary" size="40px" />
        </div>
      </template>
    </q-infinite-scroll>
  </q-page>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
// import { Todo, Meta } from 'components/models'
// import ExampleComponent from 'components/CompositionComponent.vue'
import { defineComponent /* , ref */ } from '@vue/composition-api'

// const fakeData = {
//   patient_name: 'string',
//   age: '58',
//   gender: 'M',
//   location: 'string',
//   attendant_name: 'string',
//   phone: '9876543210',
//   spo2: '99',
//   requirement: 'string',
//   status: '1',
//   case_id: '9f992567-698d-40b8-a580-ee87c12957a'
// }

export default defineComponent({
  name: 'Index',
  // components: { ExampleComponent },
  // setup () {
  //   const todos = ref<Todo[]>([
  //     {
  //       id: 1,
  //       content: 'ct1'
  //     },
  //     {
  //       id: 2,
  //       content: 'ct2'
  //     },
  //     {
  //       id: 3,
  //       content: 'ct3'
  //     },
  //     {
  //       id: 4,
  //       content: 'ct4'
  //     },
  //     {
  //       id: 5,
  //       content: 'ct5'
  //     }
  //   ])
  //   const meta = ref<Meta>({
  //     totalCount: 1200
  //   })
  //   return { todos, meta }
  // }
  data () {
    return {
      // fakeData,
      items: [],
      page: 1,
      city: '',
      cities: []
    }
  },

  mounted () {
    this.getCities()
  },

  watch: {
    city: function (newCity, oldCity) {
      if (newCity !== oldCity) {
        this.items = []
        this.page = 1
        if (oldCity !== '') {
          this.loadCylinderData()
        }
      }
    }
  },

  methods: {
    loadCylinderData: function (_index, done) {
      if (this.city !== '') {
        this.getO2Cylinders(this.page, this.city)
          .then((o2CylinderArray) => {
            this.items.push(...o2CylinderArray)
            if (o2CylinderArray.length < 10) {
              done(true)
            } else {
              done()
            }
          })
          .catch((error) => {
            console.log(error)
            done(true)
          })
      } else {
        done()
      }
    },

    getO2Cylinders: function (page: number, city: string) {
      return this.$axios.get(`/api/cylinders?page=${page}&city=${city}`)
        // eslint-disable-next-line camelcase
        .then((response: {data}) => {
          this.page = page + 1
          return response.data
        })
    },

    actionButtonColor: function (state) {
      if (state === 1) {
        return 'info'
      } else if (state === 2) {
        return 'warning'
      } else if (state === 3) {
        return 'grey'
      } else if (state === 4) {
        return 'positive'
      }
    },

    chooseCardClass: function (status) {
      if (status === '1') {
        return 'bg-negative text-white'
      }
    },

    getCities: function () {
      this.$axios.get('/api/cylinders/cities')
        .then((response) => {
          this.cities = Object.assign(response.data)
        })
        .catch((error) => {
          console.log(error)
        })
    }

    // cylinderCitiesFilter: function (val, update, abort) {
    //   if (this.cities !== null) {
    //     update()
    //     return
    //   }

    //   update(() => {
    //     this.getCities()
    //       .then((response) => {
    //         this.cities = Object.assign(response.data)
    //         this.cities.push(response.data)
    //       })
    //       .catch((error) => {
    //         console.log(error)
    //       })
    //   })
    // }
  }
})
</script>
